#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

typedef char* GPerlFilename_ornull;

void*
gperl_alloc_temp (int nbytes)
{
	dTHR;
	SV * s;
	s = sv_2mortal (NEWSV (0, nbytes));
	memset (SvPVX (s), 0, nbytes);
	return SvPVX (s);
}

char *
gperl_filename_from_sv (SV *sv)
{
        dTHR;
        char *lname;
        STRLEN len;
        char *filename = SvPVutf8 (sv, len);
	warn("gperl_filename_from_sv: got \"%s\"", filename);

        lname = gperl_alloc_temp (len + 1);
        memcpy (lname, filename, len);
	warn("gperl_filename_from_sv: dup \"%s\"", lname);

        return lname;
}

void 
gtk_image_new_from_file(char *filename)
{
    warn("gtk_image_new_from_file(%s)", filename);
}


MODULE = Bar		PACKAGE = Bar		

void
simple(sv)
    SV *sv
  CODE:
    char *str;
    STRLEN len;
    str = SvPV(sv, len);
    warn("simple(%s)", str);

void
gtk_image_new_from_file (class, filename)
	GPerlFilename_ornull filename
    C_ARGS:
        filename

